Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 2136237 - Review Request: mingw-python-installer - MinGW Python installer library
Summary: Review Request: mingw-python-installer - MinGW Python installer library
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Sandro
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 2136235
TreeView+ depends on / blocked
 
Reported: 2022-10-19 17:26 UTC by Sandro Mani
Modified: 2022-11-01 11:05 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2022-11-01 11:05:21 UTC
Type: ---
Embargoed:
gui1ty: fedora-review+


Attachments (Terms of Use)

Comment 1 Sandro 2022-10-20 14:12:47 UTC
I take this one.

Comment 2 Sandro 2022-10-20 15:15:35 UTC
This package requires mingw32-python3-build and mingw64-python3-build provided by mingw-python-build (BZ#2136235), which has not yet been reviewed. I saw that this available in you Copr repo. Maybe I should start with that review first.?

Comment 3 Sandro Mani 2022-10-20 15:23:41 UTC
They both depend on each-other, hence the bootstrapping logic. Don't see any other way than reviewing this and mingw-python-pep517 with

%bcond_without bootstrap

rather than

%bcond_with bootstrap


Spec URL: https://smani.fedorapeople.org/review/mingw-python-installer.spec
SRPM URL: https://smani.fedorapeople.org/review/mingw-python-installer-0.5.1-1.fc38~bootstrap.src.rpm

Comment 4 Sandro 2022-10-20 17:05:54 UTC
I see. Just looked at the spec file of mingw-python-build, which has an unconditional requirement for mingw{32,64}-python3-installer. I'll review that as well since you picked up scikit-misc too. I'll start with this one.

Comment 5 Sandro 2022-10-20 20:39:14 UTC
I tried a build from the bootstrap SRPM local and in Copr. Both fail with:

Processing files: mingw32-python3-installer-0.5.1-1.fc38~bootstrap.noarch
error: File must begin with "/": %{mingw32_python3_hostsitearch}/installer/
error: File must begin with "/": %{mingw32_python3_hostsitearch}/installer-0.5.1+rpmbootstrap.dist-info

Looks like an unexpanded macro. Is that a leftover from the abandoned BZ#2134021?

My Copr build: https://copr.fedorainfracloud.org/coprs/gui1ty/reviews/build/4962439/

Comment 6 Sandro Mani 2022-10-20 20:51:04 UTC
Oh, actually no, that's a macro I've introduced in mingw-python3-3.11 in COPR, but not yet backported to mingw-python3-3.10 in rawhide. I've now added it to mingw-python3-3.10.7-3.fc38.

Comment 7 Sandro 2022-10-21 18:55:33 UTC
Question:

[!]: %check is present and all tests pass.

The PyPI tarball does include tests. What's the reason %check has been omitted entirely?

For the rest it's looking good!

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "MIT License", "*No copyright* MIT
     License". 55 files have unknown license. Detailed output of
     licensecheck in /var/lib/copr-rpmbuild/results/mingw-python-
     installer/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[!]: %check is present and all tests pass.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Cannot parse rpmlint output:


Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Source checksums
----------------
https://files.pythonhosted.org/packages/source/i/installer/installer-0.5.1.tar.gz :
  CHECKSUM(SHA256) this package     : f970995ec2bb815e2fdaf7977b26b2091e1e386f0f42eafd5ac811953dc5d445
  CHECKSUM(SHA256) upstream package : f970995ec2bb815e2fdaf7977b26b2091e1e386f0f42eafd5ac811953dc5d445


Requires
--------
mingw32-python3-installer (rpmlib, GLIBC filtered):
    mingw32(kernel32.dll)
    mingw32(python(abi))
    mingw32(shlwapi.dll)
    mingw32-crt
    mingw32-filesystem

mingw64-python3-installer (rpmlib, GLIBC filtered):
    mingw64(kernel32.dll)
    mingw64(python(abi))
    mingw64(shlwapi.dll)
    mingw64-crt
    mingw64-filesystem



Provides
--------
mingw32-python3-installer:
    mingw32(python3.10dist(installer))
    mingw32(python3dist(installer))
    mingw32-python3-installer

mingw64-python3-installer:
    mingw64(python3.10dist(installer))
    mingw64(python3dist(installer))
    mingw64-python3-installer



Generated by fedora-review 0.8.0 (e988316) last change: 2022-04-07
Command line :/usr/bin/fedora-review --no-colors --prebuilt --rpm-spec --name mingw-python-installer --mock-config /var/lib/copr-rpmbuild/results/configs/child.cfg
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Ocaml, SugarActivity, PHP, fonts, Haskell, Java, Perl, R, C/C++, Python
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 8 Sandro Mani 2022-10-21 19:30:16 UTC
Generally for MinGW packages tests are omitted as they cannot be executed with cross-compiled binaries unless you pull in Wine. For platform-independent packages like pure-python modules, tests could be run, but I've not yet set up any macros to do so. I'd rather first finish the python-3.11 migration and then look into it at a later time.

Comment 9 Sandro 2022-10-30 13:24:33 UTC
One last nitpick:

- README.md is missing in %files
=> tarball provides README.md. Please include it as %doc

Going by your Copr build the dependencies will work out and everything builds. I'm not gonna redo that exercise.

Package is approved.

Comment 10 Gwyn Ciesla 2022-10-31 17:16:37 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/mingw-python-installer

Comment 11 Fedora Update System 2022-11-01 10:58:15 UTC
FEDORA-2022-f7a5568776 has been submitted as an update to Fedora 38. https://bodhi.fedoraproject.org/updates/FEDORA-2022-f7a5568776

Comment 12 Fedora Update System 2022-11-01 11:05:21 UTC
FEDORA-2022-f7a5568776 has been pushed to the Fedora 38 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.